#ifndef __mouserptparser_h__
#define __mouserptparser_h__

class MouseRptParser : public MouseReportParser {
  int xPos;
  int yPos;
  virtual void OnMouseMove(MOUSEINFO *mi);  
  protected:
    virtual void OnLeftButtonUp(MOUSEINFO *mi);
    virtual void OnLeftButtonDown(MOUSEINFO *mi);
    virtual void OnRightButtonUp(MOUSEINFO *mi);
    virtual void OnRightButtonDown(MOUSEINFO *mi);
    virtual void OnMiddleButtonUp(MOUSEINFO *mi);
    virtual void OnMiddleButtonDown(MOUSEINFO *mi);
};

void MouseRptParser::OnMouseMove(MOUSEINFO *mi) {
  xPos = xPos+(mi->dX);
  yPos = yPos+(mi->dY);
  if (xPos < -512){
    xPos = -512;
  }
  if (xPos > 512){
    xPos = 512;
  }
  if (yPos < -512){
    yPos = -512;
  }
  if (yPos > 512){
    yPos = 512;
  }
 
  Joystick.X(map(xPos,-512,512,0,1023));
  Joystick.Y(map(yPos,-512,512,0,1023)); 

  Serial.print(F(" xPos="));
  Serial.print(xPos);
  Serial.print(F("  yPos="));
  Serial.println(yPos); 

};

void MouseRptParser::OnLeftButtonUp(MOUSEINFO *mi) {
  Joystick.button(5,0);

  Serial.println(F("L Butt Up"));
};

void MouseRptParser::OnLeftButtonDown(MOUSEINFO *mi) {
  Joystick.button(5,1);

  Serial.println(F("L Butt Dn"));
};

void MouseRptParser::OnRightButtonUp(MOUSEINFO *mi) {
  Joystick.button(4,0);

  Serial.println(F("R Butt Up"));
};

void MouseRptParser::OnRightButtonDown(MOUSEINFO *mi) {
  Joystick.button(4,1); 
 
  Serial.println(F("R Butt Dn"));
};

void MouseRptParser::OnMiddleButtonUp(MOUSEINFO *mi) {
  Joystick.button(3,0);

  Serial.println(F("M Butt Up"));
};

void MouseRptParser::OnMiddleButtonDown(MOUSEINFO *mi) {
  Joystick.button(3,1);
 
  Serial.println(F("M Butt Dn"));
};

#endif
